/**************************************************************************
 *	Copyright (C) 2004-2006  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_WXFE3D_FRAME
#define H_WXFE3D_FRAME

#include "fe_include.hpp"
#include "fe_core.hpp"
#include "wxfe3d_glcanvas.hpp"

class Fe3DFrame: public wxFrame
{
public: //
    static Fe3DFrame* Create(Fe3DFrame *parentFrame, FeCore *core);

    void OnExit(wxCommandEvent& event);
    void OnNewWindow(wxCommandEvent& event);
	void OnTimer(wxTimerEvent& event);

	void setCore(FeCore* core) { m_Core = core; }
	
	~Fe3DFrame()
	{
		if(m_Canvas){
//			delete m_Canvas;
//			m_Canvas = 0;
		}	
	}

private:
    Fe3DFrame(wxWindow *parent, const wxString& title, const wxPoint& pos, 
		const wxSize& size, long style = wxDEFAULT_FRAME_STYLE);

    Fe3DGLCanvas	*m_Canvas;
	FeCore			*m_Core;

	wxTimer			m_Timer;

    DECLARE_EVENT_TABLE()
};

#endif // H_WXFE3D_FRAME
