/**************************************************************************
 *	Copyright (C) 2004-2006  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_WXFE3D_GLCANVAS
#define H_WXFE3D_GLCANVAS

#include "fe_include.hpp"
#include "fe_core.hpp"

// Define a new frame type
class Fe3DGLCanvas : public wxGLCanvas
{
//    friend class MyFrame;
public:
    Fe3DGLCanvas( wxWindow *parent, wxWindowID id = wxID_ANY,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = 0, const wxString& name = _T("TestGLCanvas") );
/*
    Fe3DGLCanvas( wxWindow *parent, const Fe3DGLCanvas *other,
        wxWindowID id = wxID_ANY, const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize, long style = 0,
        const wxString& name = _T("TestGLCanvas") );
*/
    ~Fe3DGLCanvas();

    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void OnEraseBackground(wxEraseEvent& event);
    void OnEnterWindow(wxMouseEvent& event);
	void OnTimer(wxTimerEvent& event);

	// Menu Events
	void OnMainOpen(wxCommandEvent& event);
	void OnMainLaunch(wxCommandEvent& event);
	void OnMainSave(wxCommandEvent& event);
//	void OnMainSaveAs(wxCommandEvent& event);
	void OnMainClear(wxCommandEvent& event);
	void OnQuit(wxCommandEvent& event);

	// Mouse Handling
	void OnMouseMotion(wxMouseEvent& event);
	void OnMouseButtonLD(wxMouseEvent& event);
	void OnMouseButtonLU(wxMouseEvent& event);
	void OnMouseButtonRD(wxMouseEvent& event);
	void OnMouseButtonRU(wxMouseEvent& event);

	void InitGL();
    void Render();
	void RenderSelect(int x, int y);

	void setCore(FeCore* core) { m_Core = core; };

private: // Data
	bool				m_Init;
	bool				m_Dirty;
	FeCore*				m_Core;

	wxTimer				m_Timer;
	wxMenu				m_MainPopup;
//	wxFileDropTarget	m_DropTarget;

DECLARE_EVENT_TABLE()
};

#endif // H_WXFE3D_GLCANVAS
