/**************************************************************************
 *	Copyright (C) 2006-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#include "fe_include.hpp"
#include "fe_os_rgx.hpp"
#include "regexp/Matcher.h"
#include "regexp/Pattern.h"

void FeOSClassRgx::setType(string t)
{ 
	m_Type = t;
	patType = Pattern::compile(t);
}

void FeOSClassRgx::setVendor(string v) {
	m_Vendor = v;
	patVendor = Pattern::compile(v);
}

void FeOSClassRgx::setFamily(string f) {
	m_Family = f; 
	patFamily = Pattern::compile(f);	
}

void FeOSClassRgx::setGen(string gen) {
	m_Generation = gen; 
	patGen = Pattern::compile(gen);	
}

FeOSClassRgx::FeOSClassRgx(string type, string vendor, string family, int acc)
{ 
	m_Accuracy = acc;
	patType = patVendor = patFamily = patGen = 0;
	
	setType(type);
	setVendor(vendor);
	setFamily(family);
}

FeOSClassRgx::~FeOSClassRgx()
{
	delete patType;
	delete patVendor;
	delete patFamily;
	delete patGen;
}

FeOSMatchRgx::FeOSMatchRgx(string name, int acc, int line )
{
	m_Line = line;
	m_Accuracy = acc;
}

FeOSMatchRgx::~FeOSMatchRgx()
{
	
}

bool operator==(FeOSClassRgx& p, FeOSClass& t)
{
	bool type = p.getTypePat()->findAll(t.getType()).size() > 0;
	bool vendor = p.getVendorPat()->findAll(t.getVendor()).size() > 0;
	bool gen = p.getGenPat()->findAll(t.getGen()).size() > 0;

	return (type && vendor && gen);
}

bool operator==(FeOSMatchRgx& p, FeOSMatch& t)
{
	return false;
}

