/**************************************************************************
 *	Copyright (C) 2004-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_CONFIG
#define H_FE3D_CONFIG

#include "fe_include.hpp"
#include "fe_xml_util.hpp"
#include "tex_cache.hpp"

XERCES_CPP_NAMESPACE_USE

class FeConfig : public DefaultHandler //, private XMLFormatTarget //: public HandlerBase
{

public: // SAX2 Functionality
    void startElement(	const   XMLCh* const    uri,
						const   XMLCh* const    localname,
						const   XMLCh* const    qname,
					    const   Attributes&		attributes);

	void endElement( const XMLCh* const uri,
					 const XMLCh* const localname,
					 const XMLCh* const qname);

	void endDocument();
    void fatalError(const SAXParseException&);

public: 
	// wxWidgets settings Saving / Loading
	bool LoadConfig();
	bool SaveConfig();

public: // Setter / Getters
	std::string getDataDir() { return m_DataDir; };
	void setDataDir(std::string dd) { m_DataDir = dd; };
		
	std::string getMatchFile() { return m_MatchFile; };
	void setMatchFile(std::string mf) { m_MatchFile = mf; };
		
	int	getWidth() { return m_Width; }
	int	getHeight() { return m_Height; }

	void setWindowSize(int w, int h) 
	{ m_Width = w; m_Height = h; }

	float getRootTilt() { return m_RootTilt; }
	std::string getRootTex() { return m_RootTex; }
	
	wxConfig* getWxConfig() { return m_wxConfig; }

public: // Construction / Destruction
	FeConfig();
	~FeConfig();

private: // Settings data

	wxConfig*		m_wxConfig;

	std::string	m_DataDir;
	std::string	m_ConfigFile;	// This should be more flexible than this
	std::string	m_MatchFile;

	int		m_Width;
	int		m_Height;

	bool enableEarth;
	float m_RootTilt;
	std::string m_RootTex;

public: // Kill this off
	float rotSpeed;
};

#endif // H_FE3D_CONFIG
