/**************************************************************************
 *	Copyright (C) 2004-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************
 *	Contains misc defines and data types for fe3d
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_FE_DEFINES
#define H_FE3D_FE_DEFINES

enum PortState { ps_Closed, ps_Open, ps_Filtered };
enum PortProto { pp_TCP, pp_UDP };
enum AddrType { at_MAC, at_IPV4, at_IPV6 };

namespace ICMATH
{
	const float PI = 3.14159265f;
	const float TWOPI = 2*PI;
	const float PID2 = PI/2;
	const float SQRT_3 = 1.73205081f;
}

#ifndef FE_DATA_DIR
# define FE_DATA_DIR "./data/"
#endif

#ifndef FE_DATA_FILE
# define FE_DATA_FILE( x ) FE_DATA_DIR #x
#endif

#ifdef WIN32
#if FE3D_BUILD_LIB
# define FE3D_DECL __declspec(dllexport)
#else
# define FE3D_DECL __declspec(dllimport)
#endif
#else
# define FE3D_DECL
#endif

struct xyz { float x, y, z; };

//TODO Move this somewhere else

class NodeSelect
{
public:
	NodeSelect()
	{
		m_HitCount = 0;
		m_Hits = 0;
		m_LocalHitCount = 0;
		m_LocalHits = 0;
	}

public:
	int m_HitCount;
	unsigned int *m_Hits;
	
	int m_LocalHitCount;
	unsigned int *m_LocalHits;
};

template <class T> class deleter
{
public:
	void operator()(T* t) { delete t; }
};

#endif // H_FE3D_FE_DEFINES
