/**************************************************************************
 *	Copyright (C) 2004-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_FE_DRAW
#define H_FE3D_FE_DRAW

#include "gl_util.hpp"
#include "fe_include.hpp"
#include "tex_cache.hpp"
#include "geo_cache.hpp"

class FeDraw
{
public: // Geometry Generation
	static Geo* getGeo_Square(float width, float height);
	static Geo* getGeo_WireCircle(int n, float radius);
	static Geo* getGeo_Circle(int n, float outRadius, float inRadius);
	static Geo* getGeo_Box(float width, float height, float depth);
	static Geo* getGeo_Cylinder(int n, float radius, float height, bool full_texture);
	static Geo* getGeo_Sphere(float r, int n = 16);
	static Geo* getGeo_IP();

public: // Misc drawing functions
	static void renderFoldWidget(bool plus);
};


#endif // H_FE3D_FE_DRAW
