/**************************************************************************
 *	Copyright (C) 2004-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_FE_SCAN_NODE
#define H_FE3D_FE_SCAN_NODE

#include "fe_include.hpp"
#include "fe_node.hpp"
#include "fe_host.hpp"
#include "fe_tools.hpp"

using namespace std;

class FE3D_DECL FeHostsNode :  public FeNode
{
public: // Rendering
	virtual void render();
	virtual void RenderSelect();
	virtual void renderProgress();

public: // Event handling
	virtual bool handleEvent(Event *e);

public: // Node handling
	FeHost* getNewHost();

public: // File handling
	virtual wxXmlNode* GetXMLNode();
	
public:	// Construction / Destruction
	FeHostsNode(const char *label, FeTool* tool);

private: // Internal Data
	string		m_Label;
	
	Geo*		m_Geo;
	Tex*		m_LabelTex;
	Geo*		m_ScanGeo;
	Tex*		m_ScanTex;

	float		m_ScanRot;

	FeTool*		m_Tool;
	string		m_ToolFile;
	string		m_ToolCommand;
	bool		m_ToolWorking;
};

#endif // H_FE3D_FE_SCAN_NODE

