/**************************************************************************
 *	Copyright (C) 2004-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_FE_INCLUDE
#define H_FE3D_FE_INCLUDE

#ifdef HAVE_CONFIG_H
# include "auto_config.h"
#endif

// wxWidgets Includes
#include "wx/wxprec.h"

//#ifdef __BORLANDC__
//#pragma hdrstop
//#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#ifndef wxUSE_GLCANVAS
    #error "OpenGL required: set wxUSE_GLCANVAS to 1 and rebuild the library"
#endif // wxUSE_GLCANVAS

#include <wx/config.h>
#include <wx/cmdline.h>
#include <wx/dnd.h>
#include <wx/event.h>
#include <wx/filename.h>
#include <wx/filepicker.h>
#include <wx/glcanvas.h>
#include <wx/process.h>
#include <wx/stdpaths.h>
#include <wx/stream.h>
#include <wx/txtstrm.h>
#include <wx/thread.h>
#include <wx/xml/xml.h>

// Windows
#ifdef WIN32
# define WIN32_LEAN_AND_MEAN
# include <windows.h>
# ifdef _DEBUG
#  include <crtdbg.h>
#  define _CRTDBG_MAP_ALLOC	// For memory leak checking
# endif
#else
# include <unistd.h>
#endif

#ifdef FE3D_PYTHON
# ifdef _DEBUG
#  undef _DEBUG
#  include <Python.h>
#  define _DEBUG
# else
#  include <Python.h>
# endif
#endif // FE3D_PYTHON

#if defined(__APPLE__) && defined(__MACH__)
#include <OpenGL/gl.h>	// Header File For The OpenGL32 Library
#include <OpenGL/glu.h>	// Header File For The GLu32 Library
//#include <OpenGL/glext.h>
#else
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
//#include <GL/glext.h>
#endif

// STL Stuff
#ifdef HAVE_CSTDLIB
#include <cstdlib>
#else
#include <stdlib.h>
#endif

#include <string>
#include <vector>
#include <map>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <cwchar>
#include <cstring>
#include <cmath>
#include <stack>

#include "fe_defines.hpp"

#endif //H_FE3D_FE_INCLUDE
