/**************************************************************************
 *	Copyright (C) 2005-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_FE_OS
#define H_FE3D_FE_OS

#include "fe_include.hpp"
#include "fe_defines.hpp"

using namespace std;

class FeOSClass
{
public: // Setters / Getters
	void setType(string t) { m_Type = t; };
	string getType() { return m_Type; };

	void setVendor(string v) { m_Vendor = v; };
	string getVendor() { return m_Vendor; };

	void setFamily(string f) { m_Family = f; };
	string getFamily() { return m_Family; };
	
	void setGen(string gen) { m_Generation = gen; };
	string getGen() { return m_Generation; };

public:	// Construction / Destruction
	FeOSClass(string type, string vendor, string family, int acc)
		: m_Type(type), m_Vendor(vendor), m_Family(family), 
		m_Generation(""), m_Accuracy(acc)
	{ };

	FeOSClass() : m_Type("*"), m_Vendor("*"), m_Family("*"), 
		m_Generation("*"), m_Accuracy(0)
	{ };

protected: // Data
	string m_Type;
	string m_Vendor;
	string m_Family;
	string m_Generation;

	unsigned int m_Accuracy;
};

class FeOSMatch
{
public: // Setters / Getters
	void setLine(int line) { m_Line = line; };
	int getLine() { return m_Line; };	

	string getName() { return m_Name; };

public:	// Construction / Destruction
	FeOSMatch(string name, int acc = 0, int line = 0)
		: m_Name(name), m_Accuracy(acc), m_Line(line)
	{ };
	
	FeOSMatch() : m_Name("*"), m_Accuracy(0), m_Line(0)
	{ };

protected: // Data
	string m_Name;
	unsigned int m_Accuracy;
	int m_Line;
};

#endif // H_FE3D_FE_OS

