/**************************************************************************
 *	Copyright (C) 2006-2007 iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_FE_OS_RGX
#define H_FE3D_FE_OS_RGX

#include "fe_os.hpp"
#include "regexp/Pattern.h"

using namespace std;

class FeOSClassRgx : FeOSClass
{
public: // Setters / Getters
	void setType(string t);
	Pattern *getTypePat() { return patType; };
	void setVendor(string v);
	Pattern *getVendorPat() { return patVendor; };
	void setFamily(string f);
	Pattern *getFamilyPat() { return patFamily; };
	void setGen(string g);
	Pattern *getGenPat() { return patGen; };
	
public: // Construction / Destruction
	FeOSClassRgx(string type, string vendor, string family, int acc);
	FeOSClassRgx() {};
	~FeOSClassRgx();
	
protected:
	Pattern	*patType;
	Pattern *patVendor;
	Pattern *patFamily;
	Pattern *patGen;
	
};

class FeOSMatchRgx : FeOSMatch
{
	
public: // Construction / Destruction
	FeOSMatchRgx() {};
	FeOSMatchRgx(string name, int acc, int line );
	~FeOSMatchRgx();
	
private:
	Pattern *patName;
};

bool operator==(FeOSClassRgx& p, FeOSClass& t);
bool operator==(FeOSMatchRgx& p, FeOSMatch& t);

#endif // H_FE3D_FE_OS_RGX

