/**************************************************************************
 *	Copyright (C) 2005-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_FE_TOOLS
#define H_FE3D_FE_TOOLS

#include "fe_include.hpp"
#include "fe_defines.hpp"

class FE3D_DECL FeTool : public wxEvtHandler
{
public: // Core Functions
	bool launch(std::vector<wxString>* args);
	bool checkFinished();
	bool checkError();

public: // Setters / Getters
	void setOutputArg(wxString outputArg) { m_OutputArg = outputArg; }
	void setOutputFile(wxString outputFile) { m_OutputFile = outputFile; }
	wxString getOutputFile() { return m_OutputFile; }

	bool outFileReady();

	// Ugly hack
	static void setParent(wxWindow* parent) { m_Parent = parent; }

public: // Event Handling
	void OnToolEnd(wxProcessEvent& event);

public:	// Construction / Destruction
	FeTool(wxString name, wxString path, wxString exec);

protected: // Data
	wxString 	m_Name;
	wxString 	m_Path;
	wxString 	m_Exec;
	
	bool		m_Finished;
	bool		m_Error;
	
	wxString 	m_OutputArg;
	wxString 	m_OutputFile;
	wxString	m_Cmd;

	wxProcess*		m_Process;
	wxInputStream*	m_ErrorStream;
	wxInputStream*	m_OutputStream;

	static wxWindow*	m_Parent;

DECLARE_EVENT_TABLE()
};

class FeTools
{
public: // Setters / Getters
	
public:	// Construction / Destruction

protected: // Data

};

#endif // H_FE3D_FE_OS

