/**************************************************************************
 *	Copyright (C) 2004-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_GEO_CACHE
#define H_FE3D_GEO_CACHE

#include "gl_util.hpp"
#include "fe_include.hpp"

class FE3D_DECL Geo
{

public:
	void render();

public: // Construction / Destruction
	Geo(GLenum f, GLenum m, int c);
	~Geo();

public: // Transformations
	void setTransform(float x, float y, float z);
	void setRotation(float ang, float x, float y, float z);

public: // Setter / Getters
	int getCount() { return m_Count; }
	GLenum getFormat() { return m_Format; }
	GLenum getMode() { return m_Mode; }
	float* getData() { return data; }

public:
	float*	data;	// Vertex Data

private: // Data
	int		m_Count;	// Vertex Count
	GLenum	m_Format;	// Interleved format
	GLenum	m_Mode;	// Rendering mode)

	float	trans[3];	// Translation
	float	rotate[4];  // Rotation
};

class FE3D_DECL GeometryCache
{

public: // Store Management functions;
	void addGeometry(std::string id, Geo *g);
	Geo* getGeometry(const char* id); //std::string id);

public: // Initialization
	static GeometryCache* instance();

public: // Construction / Destruction
	GeometryCache();
	~GeometryCache();

private: // Data
	static GeometryCache* _instance;
	std::map<std::string,Geo*> m_GeoCache;
};

#endif // H_FE3D_GEO_CACHE
