/**************************************************************************
 *	Copyright (C) 2004-2007  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef H_FE3D_NMAP_PARSER
#define H_FE3D_NMAP_PARSER

#include "fe_include.hpp"
#include "fe_host.hpp"
#include "fe_hosts.hpp"
#include "fe_xml_util.hpp"


XERCES_CPP_NAMESPACE_USE

class NmapParser : public DefaultHandler
{

public: // SAX Functionality
    void startElement(	const   XMLCh* const    uri, 
						const   XMLCh* const    localname,
						const   XMLCh* const    qname,
						const   Attributes&		attributes);

	void endElement( const XMLCh* const uri,
					 const XMLCh* const localname,
					 const XMLCh* const qname);
	void endDocument();
    void fatalError(const SAXParseException&);

public:
	NmapParser(FeHostsNode *node);
	~NmapParser();

private: // Data
	FePort		*m_CurPort;
	FeHost 		*m_CurHost;
	FeHostsNode	*m_Node;

	bool		m_Valid;
};


#endif //H_FE3D_NMAP_PARSER

