/**************************************************************************
 *	Copyright (C) 2004-2006  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#include "fe_include.hpp"
#include "wxfe3d_frame.hpp"
#include "wxfe3d_icon.xpm"

// HACK: For the ugly hack
#include "fe_tools.hpp"
#include "version.h"

/* -----------------------------------------------------------------------
  Main Window
-------------------------------------------------------------------------*/
#define TIMER_ID 11237

BEGIN_EVENT_TABLE(Fe3DFrame, wxFrame)
    EVT_MENU(wxID_EXIT, Fe3DFrame::OnExit)
	EVT_TIMER(TIMER_ID, Fe3DFrame::OnTimer)
END_EVENT_TABLE()

Fe3DFrame::Fe3DFrame(wxWindow *parent, const wxString& title, const wxPoint& pos,
    const wxSize& size, long style) : wxFrame(parent, wxID_ANY, title, pos, size, style)
{
    m_Canvas = 0;
    SetIcon(wxIcon(sample_xpm));
	m_Timer.Start(100);
}

// Intercept menu commands
void Fe3DFrame::OnExit( wxCommandEvent& WXUNUSED(event) )
{
    Close(true);
}

Fe3DFrame* Fe3DFrame::Create(Fe3DFrame *parentFrame, FeCore *core)
{
	wxString str = _("fe3d - ");
			str = str + _(PRODUCT_VERSION) + _(" (build: ") + _(FE_BUILD_NUM) + _(")");
	
    Fe3DFrame *frame = new Fe3DFrame(NULL, str, wxDefaultPosition,
        wxSize(core->getConfig()->getWidth(), core->getConfig()->getHeight()));

	frame->setCore(core);
	frame->m_Canvas = new Fe3DGLCanvas(frame, wxID_ANY, wxDefaultPosition, wxDefaultSize);
	frame->m_Canvas->setCore(core);

#ifdef DEBUG
	FeHostsNode* node = new FeHostsNode(FE_DATA_FILE(nmap-test.xml), 0);
	core->loadScan(FE_DATA_FILE(nmap-test.xml), node);
#endif
	
	FeTool::setParent(frame);

    // Show the frame
    frame->Show(true);
    return frame;
}

void Fe3DFrame::OnTimer(wxTimerEvent& event)
{
    m_Core->tick();
}
